<?
include_once("dirfiles.inc");

function auth_read($path, $user)
{
   global $photoroot;
   global $anonread;
   global $readacl;

   $parts = explode("/", $path);
   $priv = "";
   if($user != "")
   {
      $priv = "{$readacl}/{$user}";
   }

   // Check the path perms, from $photoroot to $photoroot/$path,
   // making sure each level is authorized.
   $check = $photoroot;
   $done = 0;
   while(! $done)
   {
      //print "Checking...  {$check}\n";
      // check current path...
      $approved = 0;
      if(file_exists("{$check}/{$anonread}")) {$approved = 1; }
      elseif($user != "")
      {
	 if(file_exists("{$check}/{$priv}")) {$approved = 1; }
      }
      // if not approved, return false
      if(!$approved) return 0;
      //else {print "... okay<br>\n";}
      // if no parts left, return true
      $s = sizeof($parts);
      /*
      print "Remaining: {$s} (\n";
      foreach ($parts as $p)
      {
	 print " / {$p}\n";
      }
      print ")<br>\n";
      */
      if(sizeof($parts) == 0) return 1;
      // add to current path...
      $check = $check . "/" . array_shift($parts);
   }
   return 0;
}

function read_dir($path, $user)
{
   // return a list of files, where each file is a dirfile object,
   // with its mimetype, basename, wwwpath?, and fullpath? filled in...
   // (other data must be loaded explicitly)
   // don't return *real* files; only dirfiles
   global $photoroot;
   global $anonread;
   global $readacl;

   // check if dir is readable
   $allowed = auth_read($path, $user);
   //print "auth_read({$path}, {$user}) => {$allowed}<br>\n";
   if(!$allowed) { return -1; }

   // read contents of dir
   $allfiles = get_dir_array($path);

   // TODO: filter out dotfiles

   // filter contents by permissions
   $result = array();
   if($user == "")
   {
      // return all public entries
      foreach ($allfiles as $f)
      {
	 $fpath = "{$photoroot}/{$path}/{$f}";
	 //print "Check access for {$f}...\n";
	 $p = "{$photoroot}/{$path}/{$f}/{$anonread}";
	 //print "{$p}\n";
	 if(file_exists($p)) { 
	    $df = dirfile($fpath);
	    $df->anonread = 1;
	    $df->read_mime();
	    $result[] = $df; 
	    //print "okay. ({$p})\n";
	 }
	 //print "<br>\n";
      }
   }
   else
   {
      // return all public and authorized private entries
      $priv = "{$readacl}/{$user}";
      foreach ($allfiles as $f)
      {
	 $fpath = "{$photoroot}/{$path}/{$f}";
	 $p = "{$photoroot}/{$path}/{$f}/{$anonread}";
	 $p2 = "{$photoroot}/{$path}/{$f}/{$priv}";
	 if(file_exists($p)) 
	 { 
	   $df = dirfile($fpath);
	   $df->anonread = 1;
	   $df->read_mime();
	   $result[] = $df; 
	 }
	 elseif(file_exists($p2)) 
	 { 
	   $df = dirfile($fpath);
	   $df->anonread = 0;
	   $df->read_mime();
	   $result[] = $df; 
	 }
      }
   }
   return $result;
}
?>
